/* program: cmR.c */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#ifndef _WIN32
#include "cmat.h"
#endif
#include "integer.h"
#include "fun.h"
#include "primes.h"

MPR *R[M0];
POLYR PR[M0];
MPMATR *RM[M0];
MPMATPR *PRM[M0];

unsigned int VERSION=1;
char cR[20], cPR[20], cRM[20], cPRM[20];
extern long int nettbytes;

int main()
{
#ifndef _WIN32
	readrc();
#endif
	INITMPIBANK();
#ifdef _WIN32
	printf("\n\n\n\n\n\n\n\n\n\n\n\n\n");
	printf("\t\t\tCMATR: VERSION 2.1: 4th July 2010\n");
	printf("\n\n");
	printf("\tAuthor:Dr.K.R. MATTHEWS\n\n\n\n");
	printf("\tBRISBANE, AUSTRALIA\n\n\n\n");
	printf("\thttp://www.numbertheory.org/keith.html\n\n\n\n");
	printf("\n\n\n\n");
	GetReturn();
#endif
	menuinit("menuR.dat");
	CAL_R();
	menuend();
	exit (0);
}

void STARTUP_R()
{
	unsigned int i;
	FILE *fp;

	strcpy(cR, "cR");
	strcpy(cPR, "cPR");
	strcpy(cRM, "cRM");
	strcpy(cPRM, "cPRM");
	if ((fp = fopen(cR, "r")) == NULL)
	{
		for (i = 0; i < M0; i++)
			R[i] = ZEROR();
		FPRINT_R(cR);
	}
	else
	{
		fclose(fp);
	}
	if ((fp = fopen(cPR, "r")) == NULL)
	{
		for (i = 0; i < M0; i++)
			PR[i] = NULL;
		FPRINT_PR(cPR);
	}
	else
		fclose(fp);
	if ((fp = fopen(cRM, "r")) == NULL)
	{
		for (i = 0; i < M0; i++)
			RM[i] = ZEROMNR(1, 1);
		FPRINTMAT_R(cRM);
	}
	else
		fclose(fp);
	if ((fp = fopen(cPRM, "r")) == NULL)
	{
		for (i = 0; i < M0; i++)
			PRM[i] = ZEROMNPR(1, 1);
		FPRINTMAT_PR(cPRM);
	}
	else
		fclose(fp);
	FINPUT_R(cR);
	FINPUT_PR(cPR);
	FINPUTMAT_R(cRM, 0);
	FINPUTMAT_PR(cPRM);
}

void FINISH_R()
{
	unsigned int i;

	for (i = 0; i < M0; i++)
	{
		FREEMPR(R[i]);
		FREEMATR(RM[i]);
		FREEMATPR(PRM[i]);
                DELETE_PR(PR[i]);
	}
	FREEMPIBANK();
#ifdef DEBUG
	printf("after cmatR nettbytes = %ld\n", nettbytes);
/*
 *	COUNTBANKI();
 *	COUNTBANKR();
 */
#endif
	GetReturn();
	return;
}

void CAL_R()
{
	int GoOnFlag = 1, GoOnFlag1, answer; 
	char c, cmd[50];

	STARTUP_R();
	while (GoOnFlag)
	{
		c = drawmenu(1);
		switch (c)
		{
		case 'i':
				clearscreen();
#ifdef _WIN32
				sprintf(cmd, "type info.dat | more");
				system(cmd);
#else
				sprintf(cmd, "%s %s/info.dat",PAGER,DATPATH);
				system(cmd);
#endif
			break;
		case 'x':
			INPUTR_();
			break;
                case 'L':
			LPRINTR_();
			break;
		case 'c':
			GoOnFlag1 = 1;
			while (GoOnFlag1)
			{
				c = drawmenu(2);
				switch (c)
				{
				case 'n':
					NumberCalcR();
					break;
				case 'p':
					PolyCalcR();
					break;
				case 'm':
					MatCalcR();
					break;
				case 'q':
					GoOnFlag1 = 0;
					break;
				}
			}
			break;
		case 'p':
			PRINTR_();
			break;
		case 'q':
			clearscreen();
			printf("y : save calculations\n");
			printf("n : do not save calculations\n\n");
			answer = GetYN();
			clearscreen();
			if (answer)
			{
				FPRINT_R(cR);
				FPRINTMAT_R(cRM);
				FPRINT_PR(cPR);
				FPRINTMAT_PR(cPRM);
			}
			else
			{
				remove(cR);
				remove(cRM);
				remove(cPR);
				remove(cPRM);
			}
			printf("Exiting rational calculator\n");
			FINISH_R();
			GoOnFlag = 0;
			break;
		}
	}
}

void NumberCalcR()
{
	int GoOnFlag = 1;
	char c;
	while (GoOnFlag)
	{
		c = drawmenu(3);
		switch (c)
		{
		case 'a':
			ADD_R();
			break;
		case 's':
			SUB_R();
			break;
		case 't':
			MULT_R();
			break;
		case 'e':
			POWER_R();
			break;
		case 'r':
			RATIO_R();
			break;
		case 'i':
			INVERSE_R();
			break;
		case 'n':
			MTHROOT_R();
			break;
		case 'x':
			INPUT_R();
			break;
		case 'p':
			PRINT_R();
			break;
		case 'q':
			GoOnFlag = 0;
			FPRINT_R(cR);
			break;
		}
	}
}

void PolyCalcR()
{
	int GoOnFlag = 1;
	char c;
	while (GoOnFlag)
	{
		c = drawmenu(4);
		switch (c)
		{
			case 'a':
				ADD_PR();
				break;
			case 's':
				SUB_PR();
				break;
			case 't':
				MULT_PR();
				break;
			case 'e':
				POWER_PR();
				break;
			case 'v':
				VAL_PR();
				break;
			case 'd':
				DERIV_PR();
				break;
			case 'f':
				SCALAR_PR();
				break;
			case 'r':
				DIV_PR();
				break;
			case 'i':
				MOD_PR();
				break;
			case 'g':
				GCD_PR();
				break;
			case 'G':
				EUCLID_PR();
				break;
			case 'L':
				EUCLIDS_PR();
				break;
			case 'z':
				FactorCalcR();
				break;
			case 'x':
				INPUTR_();
				break;
			case 'p':
				PRINT_PR();
				break;
			case 'q':
				GoOnFlag = 0;
				FPRINT_PR(cPR);
				break;
		}
	}
}

void MatCalcR()
{
	int GoOnFlag = 1;
	char c;
	while (GoOnFlag)
	{
		c = drawmenu(5);
		switch (c)
		{
		case 'm':
			MATRIX_ARITH_R();
			break;
		case 'j':
			JOINMAT_R();	
			break;
		case 'o':
			OPS_R();
			break;
		case 'v':
			ExtractR_();
			break;
		case 'c':
			MATALG_R();
			break;
		case 'f':
			DOT_R();
			break;
		case 's':
			MATRIX_ARITH_PR();
			break;
		case 'p':
			PRINTR_();
			break;
		case 'L':
			LPRINTR_();
			break;
		case 'x':
			INPUTR_();
			break;
		case 'q':
			GoOnFlag = 0;
			break;
		}
	}
}

void FactorCalcR()
{
	int GoOnFlag = 1;
	char c;

	while (GoOnFlag)
	{
		c = drawmenu(6);
		switch (c)
		{
			case 'c':
				CYCLOTOMIC_PR();
				break;
			case 'z':
				SQUAREFREE_PR();
				break;
			case 'w':
				KALTOFEN_PR();
				break;
			case 'r':
				RESULTANT_PI();
				break;
			case 'd':
				DISCRIMINANT_PI();
				break;
			case 'x':
				INPUTR_();
				break;
			case 'p':
				PRINT_PR();
				break;
			case 'q':
				GoOnFlag = 0;
				FPRINT_PR(cPR);
				break;
		}
	}
}
