
/* cm_CRM1.c */

/* complex matrix routines used in cmCR.c */

#include <stdio.h>
#include "integer.h"
#include "fun.h"

extern MPMATCR *CRM[];
extern POLYCR PCR[];
extern MPCR *CR[];

extern char cCR[];
extern char cCRM[];

void ADDMAT_CR()
{
	unsigned int j, k, l;
	MPMATCR *Temp;

	if (scanf03(&j, &k, &l) == 0)
		return;
	if (CRM[j]->R != CRM[k]->R || CRM[j]->C != CRM[k]->C)
		printf("matrices CRM[%u] and CRM[%u] have incompatible sizes\n", j, k);
	else
	{
		printf("CRM[%u] = \n", j);
		PRINTMATCR(0, CRM[j]->R - 1, 0, CRM[j]->C - 1, CRM[j]);
		printf("+ CRM[%u] = \n", k);
		PRINTMATCR(0, CRM[k]->R - 1, 0, CRM[k]->C - 1, CRM[k]);
		Temp = CRM[l];
		CRM[l] = ADDMATCR(CRM[j], CRM[k]);
		FREEMATCR(Temp);
		printf("->\n");
		printf("CRM[%u] = \n", l);
		PRINTMATCR(0, CRM[l]->R - 1, 0, CRM[l]->C - 1, CRM[l]);
	}
	GetReturn();
	return;
}

void SUBMAT_CR()
{
	unsigned int j, k, l;
	MPMATCR *Temp;

	if (scanf03(&j, &k, &l) == 0)
		return;
	if (CRM[j]->R != CRM[k]->R || CRM[j]->C != CRM[k]->C)
		printf("matrices CRM[%u] and CRM[%u] have incompatible sizes\n", j, k);
	else
	{
		printf("CRM[%u] = \n", j);
		PRINTMATCR(0, CRM[j]->R - 1, 0, CRM[j]->C - 1, CRM[j]);
		printf("- CRM[%u] = \n", k);
		PRINTMATCR(0, CRM[k]->R - 1, 0, CRM[k]->C - 1, CRM[k]);
		Temp = CRM[l];
		CRM[l] = SUBMATCR(CRM[j], CRM[k]);
		FREEMATCR(Temp);
		printf("->\n");
		printf("CRM[%u] = \n", l);
		PRINTMATCR(0, CRM[l]->R - 1, 0, CRM[l]->C - 1, CRM[l]);
	}
	GetReturn();
	return;
}

void SCALARMAT_CR()
{
	unsigned int j, k, l;
	MPMATCR *Temp;

	if (scanf03(&j, &k, &l) == 0)
		return;
	printf("CR[%u] = ", j);
	PRINTCR(CR[j]);
	printf("\ntimes\n");
	printf("CRM[%u] = \n", k);
	PRINTMATCR(0, CRM[k]->R - 1, 0, CRM[k]->C - 1, CRM[k]);
	Temp = CRM[l];
	CRM[l] = SCALARMATCR(CRM[k], CR[j]);
	FREEMATCR(Temp);
	printf("->\n");
	printf("CRM[%u] = \n", l);
	PRINTMATCR(0, CRM[l]->R - 1, 0, CRM[l]->C - 1, CRM[l]);
	GetReturn();
	return;
}

void CONJ_TRANSPOSE_CR()
{
	unsigned int j, k;
	MPMATCR *Temp;

	if (scanf02(&j, &k) == 0)
		return;
	printf("The complex conjugate transpose of CRM[%u] = \n", j);
	PRINTMATCR(0, CRM[j]->R - 1, 0, CRM[j]->C - 1, CRM[j]);
	Temp = CRM[k];
	CRM[k] = CONJ_TRANSPOSECR(CRM[j]);
	FREEMATCR(Temp);
	printf("->\n");
	printf("CRM[%u] = \n", k);
	PRINTMATCR(0, CRM[k]->R - 1, 0, CRM[k]->C - 1, CRM[k]);
	GetReturn();
	return;
}

void POWERMAT_CR()
{
	unsigned int j, k, n;
	MPMATCR *Temp;

	if (scanf12(&n, &j, &k) == 0)
		return;
	if (CRM[j]->R != CRM[j]->C)
		printf("Matrix CRM[%u] is not square\n", j);
	else
	{
		printf("The power %u of CRM[%u] = \n", n, j);
		PRINTMATCR(0, CRM[j]->R - 1, 0, CRM[j]->C - 1, CRM[j]);
		Temp = CRM[k];
		CRM[k] = POWERMATCR(CRM[j], n);
		FREEMATCR(Temp);
		printf("->\n");
		printf("CRM[%u] = \n", k);
		PRINTMATCR(0, CRM[k]->R - 1, 0, CRM[k]->C - 1, CRM[k]);
	}
	GetReturn();
	return;
}

void DIAG_CR()
{
	unsigned int j, k, l;
	MPMATCR *Temp;

	if (scanf03(&j, &k, &l) == 0)
		return;
	if (CRM[j]->R != CRM[j]->C)
		printf("Matrix CRM[%u] is not square\n", j);
	else
	{
		printf("CRM[%u] = \n", j);
		PRINTMATCR(0, CRM[j]->R - 1, 0, CRM[j]->C - 1, CRM[j]);
		printf("- CR[%u] ( = ", k);
		PRINTCR(CR[k]);
		printf(") * I[%u]\n", CRM[j]->R);
		Temp = CRM[l];
		CRM[l] = DIAGCR(CRM[j], CR[k]);
		FREEMATCR(Temp);
		printf(" ->\n");
		printf("CRM[%u] = \n", l);
		PRINTMATCR(0, CRM[l]->R - 1, 0, CRM[l]->C - 1, CRM[l]);
	}
	GetReturn();
	return;
}

void MULTMAT_CR()
{
	unsigned int j, k, l;
	MPMATCR *Temp;

	if (scanf03(&j, &k, &l) == 0)
		return;
	if (CRM[j]->C != CRM[k]->R)
		printf("matrices CRM[%u] and CRM[%u] have incompatible sizes\n", j, k);
	else
	{
		printf("CRM[%u] = \n", j);
		PRINTMATCR(0, CRM[j]->R - 1, 0, CRM[j]->C - 1, CRM[j]);
		printf("* CRM[%u] = \n", k);
		PRINTMATCR(0, CRM[k]->R - 1, 0, CRM[k]->C - 1, CRM[k]);
		Temp = CRM[l];
		CRM[l] = MULTMATCR(CRM[j], CRM[k]);
		FREEMATCR(Temp);
		printf("->\n");
		printf("CRM[%u] = \n", l);
		PRINTMATCR(0, CRM[l]->R - 1, 0, CRM[l]->C - 1, CRM[l]);
	}
	GetReturn();
	return;
}

void MINUSMAT_CR()
{
	unsigned int j, k;
	MPMATCR *Temp;

	if (scanf02(&j, &k) == 0)
		return;
	printf("- CRM[%d] = \n", j);
	PRINTMATCR(0, CRM[j]->R - 1, 0, CRM[j]->C - 1, CRM[j]);
	Temp = CRM[k];
	CRM[k] = MINUSMATCR(CRM[j]);
	FREEMATCR(Temp);
	printf("->\n");
	printf("CRM[%d] = \n", k);
	PRINTMATCR(0, CRM[k]->R - 1, 0, CRM[k]->C - 1, CRM[k]);
	GetReturn();
	return;
}

void VALMAT_CR()
{
	unsigned int j, k, l;
	MPMATCR *Temp;

	if (scanf03(&j, &k, &l) == 0)
		return;
	if (CRM[j]->R != CRM[j]->C)
		printf("matrix CRM[%u] is not square\n", j);
	else
	{
		printf("PCR[%u] = ", j);
		PRINTPCR(PCR[j]);
		printf("\nevaluated at\nCRM[%u] =\n", k);
		PRINTMATCR(0, CRM[k]->R - 1, 0, CRM[k]->C - 1, CRM[k]);
		Temp = CRM[l];
		CRM[l] = VALMATCR(PCR[j], CRM[k]);
		FREEMATCR(Temp);
		printf("\n->\nCRM[%u] =\n", l);
		PRINTMATCR(0, CRM[l]->R - 1, 0, CRM[l]->C - 1, CRM[l]);
	}
	GetReturn();
	return;
}

void MATRIX_ARITH_CR()
{
	char c;
	int GoOnFlag = 1;

	while (GoOnFlag)
	{
		c = drawmenu(7);
		switch (c)
		{
		case 'a':
			ADDMAT_CR();
			break;
		case 's':
			SUBMAT_CR();
			break;
		case 'f':
			SCALARMAT_CR();
			break;
		case '*':
			CONJ_TRANSPOSE_CR();
			break;
		case 'e':
			POWERMAT_CR();
			break;
		case 't':
			MULTMAT_CR();
			break;
		case 'm':
			MINUSMAT_CR();
			break;
		case 'z':
			DIAG_CR();
			break;
		case 'v':
			VALMAT_CR();
			break;
		case 'p':
			PRINTCR_();
			break;
		case 'x':
			INPUTCR_();
			break;
		case 'q':
			FPRINT_CR(cCR);
			FPRINTMAT_CR(cCRM);
			GoOnFlag = 0;
			break;
		}
	}
}

void JOIN_COLUMNS_CR()
{
	unsigned int j, k, l;
	MPMATCR *Temp;

	if (scanf03(&j, &k, &l) == 0)
		return;
	if (CRM[j]->R != CRM[k]->R)
		printf("matrices CRM[%u] and CRM[%u] have row numbers\n", j, k);
	else
	{
		printf("column-join CRM[%u] = \n", j);
		PRINTMATCR(0, CRM[j]->R - 1, 0, CRM[j]->C - 1, CRM[j]);
		printf("to CRM[%u] = \n", k);
		PRINTMATCR(0, CRM[k]->R - 1, 0, CRM[k]->C - 1, CRM[k]);
		Temp = CRM[l];
		CRM[l] = JCOLSMATCR(CRM[j], CRM[k]);
		FREEMATCR(Temp);
		printf("->\n");
		printf("CRM[%u] = \n", l);
		PRINTMATCR(0, CRM[l]->R - 1, 0, CRM[l]->C - 1, CRM[l]);
	}
	GetReturn();
	return;
}

void JOIN_ROWS_CR()
{
	unsigned int j, k, l;
	MPMATCR *Temp;

	if (scanf03(&j, &k, &l) == 0)
		return;
	if (CRM[j]->C != CRM[k]->C)
		printf("matrices CRM[%u] and CRM[%u] have column numbers\n", j, k);
	else
	{
		printf("row-join CRM[%u] = \n", j);
		PRINTMATCR(0, CRM[j]->R - 1, 0, CRM[j]->C - 1, CRM[j]);
		printf("to CRM[%u] = \n", k);
		PRINTMATCR(0, CRM[k]->R - 1, 0, CRM[k]->C - 1, CRM[k]);
		Temp = CRM[l];
		CRM[l] = JROWSMATCR(CRM[j], CRM[k]);
		FREEMATCR(Temp);
		printf("->\n");
		printf("CRM[%u] = \n", l);
		PRINTMATCR(0, CRM[l]->R - 1, 0, CRM[l]->C - 1, CRM[l]);
	}
	GetReturn();
	return;
}

void JCOLSIDENTITY_CR()
{
	unsigned int j, k;
	MPMATCR *Temp;

	if (scanf02(&j, &k) == 0)
		return;
	printf("join CRM[%u] = \n", j);
	PRINTMATCR(0, CRM[j]->R - 1, 0, CRM[j]->C - 1, CRM[j]);
	printf("to I[%u]\n", CRM[j]->R);
	Temp = CRM[k];
	CRM[k] = JCOLSIDENTITYCR(CRM[j]);
	FREEMATCR(Temp);
	printf("->\n");
	printf("CRM[%u] = \n", k);
	PRINTMATCR(0, CRM[k]->R - 1, 0, CRM[k]->C - 1, CRM[k]);
	GetReturn();
	return;
}

void KRONECKER_CR()
{
	unsigned int j, k, l;
	MPMATCR *Temp;

	if (scanf03(&j, &k, &l) == 0)
		return;
	printf("CRM[%d] = \n", j);
	PRINTMATCR(0, CRM[j]->R - 1, 0, CRM[j]->C - 1, CRM[j]);
	printf("KRONECKER CRM[%d] = \n", k);
	PRINTMATCR(0, CRM[k]->R - 1, 0, CRM[k]->C - 1, CRM[k]);
	Temp = CRM[l];
	CRM[l] = KRONECKERCR(CRM[j], CRM[k]);
	FREEMATCR(Temp);
	printf("->\n");
	printf("CRM[%d] = \n", l);
	PRINTMATCR(0, CRM[l]->R - 1, 0, CRM[l]->C - 1, CRM[l]);
	GetReturn();
	return;
}

void DIRECT_SUM_CR()
{
	unsigned int j, k, l;
	MPMATCR *Temp;

	if (scanf03(&j, &k, &l) == 0)
		return;
	printf("CRM[%d] = \n", j);
	PRINTMATCR(0, CRM[j]->R - 1, 0, CRM[j]->C - 1, CRM[j]);
	printf("DIRECT_SUM CRM[%d] = \n", k);
	PRINTMATCR(0, CRM[k]->R - 1, 0, CRM[k]->C - 1, CRM[k]);
	Temp = CRM[l];
	CRM[l] = DIRECT_SUMCR(CRM[j], CRM[k]);
	FREEMATCR(Temp);
	printf("->\n");
	printf("CRM[%d] = \n", l);
	PRINTMATCR(0, CRM[l]->R - 1, 0, CRM[l]->C - 1, CRM[l]);
	GetReturn();
	return;
}

void UNWRAPMAT_CR()
{
	unsigned int j, k;
	MPMATCR *Temp;

	if (scanf02(&j, &k) == 0)
		return;
	printf("unwrap CRM[%d] = \n", j);
	PRINTMATCR(0, CRM[j]->R - 1, 0, CRM[j]->C - 1, CRM[j]);
	Temp = CRM[k];
	CRM[k] = UNWRAPMATCR(CRM[j]);
	FREEMATCR(Temp);
	printf("done\n");
	GetReturn();
	return;
}

void JOINMAT_CR()
{
	char c;
	int GoOnFlag = 1;

	while (GoOnFlag)
	{
		c = drawmenu(8);
		switch (c)
		{
		case 'c':
			JOIN_COLUMNS_CR();
			break;
		case 'r':
			JOIN_ROWS_CR();
			break;
		case 'i':
			JCOLSIDENTITY_CR();
			break;
		case 'k':
			KRONECKER_CR();
			break;
		case 'd':
			DIRECT_SUM_CR();
			break;
		case 'u':
			UNWRAPMAT_CR();
			break;
		case 'q':
			FPRINTMAT_CR(cCRM);
			GoOnFlag = 0;
			break;
		}	
	}
}

void SWAP_ROWSCR_()
{
	unsigned int j, k, p, q;
	MPMATCR *Temp;

	if (scanf22(&p, &q, &j, &k) == 0)
		return;
	if (p < 1 || p > CRM[j]->R)
		printf("p < 1 or > number of rows of CRM[%u]\n", j);
	else if (q < 1 || q > CRM[j]->R)
		printf("q < 1 or > number of rows of CRM[%u]\n", j);
	else
	{
		printf("CRM[%d] = \n", j);
		PRINTMATCR(0, CRM[j]->R - 1, 0, CRM[j]->C - 1, CRM[j]);
		printf("->\n");
		Temp = CRM[k];
		CRM[k] = SWAP_ROWSCR(p - 1, q - 1, CRM[j]);
		FREEMATCR(Temp);
		printf("CRM[%d] = \n", k);
		PRINTMATCR(0, CRM[k]->R - 1, 0, CRM[k]->C - 1, CRM[k]);
	}
	GetReturn();
	return;
}

void SWAP_COLSCR_()
{
	unsigned int j, k, p, q;
	MPMATCR *Temp;

	if (scanf22(&p, &q, &j, &k) == 0)
		return;
	if (p < 1 || p > CRM[j]->C)
		printf("p < 1 or > number of columns of CRM[%u]\n", j);
	else if (q < 1 || q > CRM[j]->C)
		printf("q < 1 or > number of columns of CRM[%u]\n", j);
	else
	{
		printf("CRM[%d] = \n", j);
		PRINTMATCR(0, CRM[j]->R - 1, 0, CRM[j]->C - 1, CRM[j]);
		printf("->\n");
		Temp = CRM[k];
		CRM[k] = SWAP_COLSCR(p - 1, q - 1, CRM[j]);
		FREEMATCR(Temp);
		printf("CRM[%d] = \n", k);
		PRINTMATCR(0, CRM[k]->R - 1, 0, CRM[k]->C - 1, CRM[k]);
	}
	GetReturn();
	return;
}

void SCALAR_ROWCR_()
{
	unsigned int j, k, l, p;
	MPMATCR *Temp;

	if (scanf0112(&j, &p, &k, &l) == 0)
		return;
	if (p < 1 || p > CRM[k]->R)
		printf("p < 1 or > number of rows of CRM[%u]\n", k);
	else
	{
		printf("CRM[%u] = \n", k);
		PRINTMATCR(0, CRM[k]->R - 1, 0, CRM[k]->C - 1, CRM[k]);
		printf("->\n");
		Temp = CRM[l];
		CRM[l] = SCALAR_ROWCR(p - 1, CR[j], CRM[k]);
		FREEMATCR(Temp);
		printf("CRM[%u] = \n", l);
		PRINTMATCR(0, CRM[l]->R - 1, 0, CRM[l]->C - 1, CRM[l]);
	}
	GetReturn();
	return;
}

void SCALAR_COLCR_()
{
	unsigned int j, k, l, p;
	MPMATCR *Temp;

	if (scanf0112(&j, &p, &k, &l) == 0)
		return;
	if (p < 1 || p > CRM[k]->C)
		printf("p < 1 or > number of columns of CRM[%u]\n", k);
	else
	{
		printf("CRM[%u] = \n", k);
		PRINTMATCR(0, CRM[k]->R - 1, 0, CRM[k]->C - 1, CRM[k]);
		printf("->\n");
		Temp = CRM[l];
		CRM[l] = SCALAR_COLCR(p - 1, CR[j], CRM[k]);
		FREEMATCR(Temp);
		printf("CRM[%u] = \n", l);
		PRINTMATCR(0, CRM[l]->R - 1, 0, CRM[l]->C - 1, CRM[l]);
	}
	GetReturn();
	return;
}

void ADD_MULT_ROWCR_()
{
	unsigned int j, k, l, p, q;
	MPMATCR *Temp;

	if (scanf0122(&j, &p, &q, &k, &l) == 0)
		return;
	if (q < 1 || q > CRM[k]->R)
		printf("q < 1 or > number of rows of CRM[%u]\n", k);
	else if (p < 1 || p > CRM[k]->R)
		printf("p < 1 or > number of rows of CRM[%u]\n", k);
	else
	{
		printf("CRM[%d] = \n", k);
		PRINTMATCR(0, CRM[k]->R - 1, 0, CRM[k]->C - 1, CRM[k]);
		printf("->\n");
		Temp = CRM[l];
		CRM[l] = ADD_MULT_ROWCR(p - 1, q - 1, CR[j], CRM[k]);
		FREEMATCR(Temp);
		printf("CRM[%d] = \n", l);
		PRINTMATCR(0, CRM[l]->R - 1, 0, CRM[l]->C - 1, CRM[l]);
	}
	GetReturn();
	return;
}

void ADD_MULT_COLCR_()
{
	unsigned int j, k, l, p, q;
	MPMATCR *Temp;

	if (scanf0122(&j, &p, &q, &k, &l) == 0)
		return;
	if (q < 1 || q > CRM[k]->C)
		printf("q < 1 or > number of columns of CRM[%u]\n", k);
	else if (p < 1 || p > CRM[k]->C)
		printf("p < 1 or > number of columns of CRM[%u]\n", k);
	else
	{
		printf("CRM[%d] = \n", k);
		PRINTMATCR(0, CRM[k]->R - 1, 0, CRM[k]->C - 1, CRM[k]);
		printf("->\n");
		Temp = CRM[l];
		CRM[l] = ADD_MULT_COLCR(p - 1, q - 1, CR[j], CRM[k]);
		FREEMATCR(Temp);
		printf("CRM[%d] = \n", l);
		PRINTMATCR(0, CRM[l]->R - 1, 0, CRM[l]->C - 1, CRM[l]);
	}
	GetReturn();
	return;
}

void OPS_CR()
{
	int GoOnFlag = 1;
        char c;

	while (GoOnFlag)
	{
		c = drawmenu(9);
		switch (c)
		{
		case 'i':
			SWAP_ROWSCR_();
			break;
		case 'j':
			SWAP_COLSCR_();
			break;
		case 'm':
			SCALAR_ROWCR_();
			break;
		case 'n':
			SCALAR_COLCR_();
			break;
		case 'a':
			ADD_MULT_ROWCR_();
			break;
		case 'b':
			ADD_MULT_COLCR_();
			break;
		case 'x':
			INPUTCR_();
			break;
		case 'q':
			FPRINTMAT_CR(cCRM);
			GoOnFlag = 0;
			break;
		}
	} 
}

void ExtractCR_()
{
	char c;
	int GoOnFlag = 1;
	while (GoOnFlag)
	{
		c = drawmenu(10);
		switch (c)
		{
		case 'r':
			ExtractRow_CR();
			break;
		case 'c':
			ExtractCol_CR();
			break;
		case 'q':
			FPRINTMAT_CR(cCRM);
			GoOnFlag = 0;
			break;
		}
	}
}

void ExtractRow_CR()
{
	unsigned int j, k, q;
	MPMATCR *Temp;

	if (scanf12(&q, &j, &k) == 0)
		return;
	if (q < 1 || q > CRM[j]->R)
		printf("q < 1 or > number of rows of CRM[%u]\n", j);
	else
	{
		Temp = CRM[k];
		CRM[k] = ROWVECTORCR(CRM[j], q - 1);
		FREEMATCR(Temp);
		printf("%u-th row vector of CRM[%d] =\n", q, j);
		PRINTMATCR(0, CRM[j]->R - 1, 0, CRM[j]->C - 1, CRM[j]);
		printf("->\nCRM[%d] =\n", k);
		PRINTMATCR(0, CRM[k]->R - 1, 0, CRM[k]->C - 1, CRM[k]);
	}
	GetReturn();
	return;
}

void ExtractCol_CR()
{
	unsigned int j, k, q;
	MPMATCR *Temp;

	if (scanf12(&q, &j, &k) == 0)
		return;
	if (q < 1 || q > CRM[j]->C)
		printf("q < 1 or > number of columns of CRM[%u]\n", j);
	else
	{
		Temp = CRM[k];
		CRM[k] = ColVectorCR(CRM[j], q - 1);
		FREEMATCR(Temp);
		printf("%u-th column vector of CRM[%d] =\n", q, j);
		PRINTMATCR(0, CRM[j]->R - 1, 0, CRM[j]->C - 1, CRM[j]);
		printf("->\nCRM[%d] =\n", k);
		PRINTMATCR(0, CRM[k]->R - 1, 0, CRM[k]->C - 1, CRM[k]);
	}
	GetReturn();
	return;
}
