/* cm_CRM2.c */

/* complex matrix routines used in cmCR.c */

#include <stdio.h>
#include <stdlib.h>
#include "integer.h"
#include "fun.h"

extern MPMATCR *CRM[];
extern MPCR *CR[];
extern POLYCR PCR[];

extern char cCR[];
extern char cCRM[];
extern char cPCRM[];
extern char cPCR[];

void CHAR_POLY_CR()
{
	unsigned int j, k;
	MPMATCR *adj;
	MPCR *det;

	if (scanf02(&j, &k) == 0)
		return;
	if (CRM[j]->R != CRM[j]->C)
		printf("Matrix CRM[%u] is not square\n", j);
	else if (CRM[j]->R == 1)
		printf("Matrix CRM[%u] is 1 x 1\n", j);
	else
	{
		DELETE_PCR(PCR[k]);
		printf("the characteristic polynomial of CRM[%u] = \n\n", j);
		PRINTMATCR(0, CRM[j]->R - 1, 0, CRM[j]->C - 1, CRM[j]);
		printf("is PCR[%u] = ", k);
		PCR[k] = LEVERRIER_CR(CRM[j], &adj, &det);
		PRINTPCR(PCR[k]);
		printf("\n");
		FREEMATCR(adj);
		FREEMPCR(det);
	}
	GetReturn();
	return;
}

void MINIMUM_POLY_CR()
{
	unsigned int j, k;

	if (scanf02(&j, &k) == 0)
		return;
	if (CRM[j]->R != CRM[j]->C)
		printf("Matrix CRM[%u] is not square\n", j);
	else if (CRM[j]->R == 1)
		printf("Matrix CRM[%u] is 1 x 1\n", j);
	else
	{
		DELETE_PCR(PCR[k]);
		printf("the minimum polynomial of CRM[%u] = \n\n", j);
		PRINTMATCR(0, CRM[j]->R - 1, 0, CRM[j]->C - 1, CRM[j]);
		printf("is PCR[%u] = ", k);
		PCR[k] = MINIMUM_POLYCR(CRM[j]);
		PRINTPCR(PCR[k]);
		printf("\n");
	}
	GetReturn();
	return;
}

void ADJ_CR()
{
	unsigned int j, k;
	MPCR *det;
	POLYCR A;
	MPMATCR *Temp;

	if (scanf02(&j, &k) == 0)
		return;
	if (CRM[j]->R != CRM[j]->C)
		printf("Matrix CRM[%u] is not square\n", j);
	else if (CRM[j]->R == 1)
		printf("Matrix CRM[%u] is 1 x 1\n", j);
	else
	{
		printf("adj of CRM[%u] = \n", j);
		PRINTMATCR(0, CRM[j]->R - 1, 0, CRM[j]->C - 1, CRM[j]);
		Temp = CRM[k];
		A = LEVERRIER_CR(CRM[j], &CRM[k], &det);
		FREEMATCR(Temp);
		FREEMPCR(det);
		DELETE_PCR(A);
		printf("->\n");
		printf("CRM[%u] = \n", k);
		PRINTMATCR(0, CRM[k]->R - 1, 0, CRM[k]->C - 1, CRM[k]);
	}
	GetReturn();
	return;
}

void DET_CR()
{
	unsigned int j, k;
	MPMATCR *adj;
	POLYCR A;

	if (scanf02(&j, &k) == 0)
		return;
	if (CRM[j]->R != CRM[j]->C)
		printf("Matrix CRM[%u] is not square\n", j);
	else if (CRM[j]->R == 1)
		printf("Matrix CRM[%u] is 1 x 1\n", j);
	else
	{
	printf("det of CRM[%u] = \n", j);
	PRINTMATCR(0, CRM[j]->R - 1, 0, CRM[j]->C - 1, CRM[j]);
	FREEMPCR(CR[k]);
	A = LEVERRIER_CR(CRM[j], &adj, &CR[k]);
	DELETE_PCR(A);
	FREEMATCR(adj);
	printf("->\n");
	printf("CR[%u] = ", k);
	PRINTCR(CR[k]);
	printf("\n");
	}
	GetReturn();
	return;
}

void INVERSE_MAT_CR()
{
	unsigned int j, k;
	MPMATCR *N;

	if (scanf02(&j, &k) == 0)
		return;
	if (CRM[j]->R != CRM[j]->C)
		printf("Matrix CRM[%u] is not square\n", j);
	else if (CRM[j]->R == 1)
		printf("Matrix CRM[%u] is 1 x 1\n", j);
	else
	{
		printf("inverse of CRM[%u] = \n", j);
		PRINTMATCR(0, CRM[j]->R - 1, 0, CRM[j]->C - 1, CRM[j]);
		N = INVERSEMATCR(CRM[j]);
		if (N == NULL)
			printf("does not exist.\n");
		else
		{
			FREEMATCR(CRM[k]);
			CRM[k] = N;
			printf("->\n");
			printf("CRM[%u] = \n", k);
			PRINTMATCR(0, CRM[k]->R - 1, 0, CRM[k]->C - 1, CRM[k]);
		}
	}
	GetReturn();
	return;
}

void TRANSFORM_MAT_CR()
{
	unsigned int j, k, l;
	MPMATCR *Temp1, *Temp2, *N;

	if (scanf03(&j, &k, &l) == 0)
		return;
	if (CRM[k]->C != CRM[k]->R)
		printf("matrix CRM[%u] is not square\n", k);
	else if (CRM[j]->C != CRM[j]->R)
		printf("matrix CRM[%u] is not square\n", j);
	else if (CRM[j]->R == 1)
		printf("Matrix CRM[%u] is 1 x 1\n", j);
	else if (CRM[k]->R == 1)
		printf("Matrix CRM[%u] is 1 x 1\n", k);
	else if (CRM[j]->R != CRM[k]->R)
		printf("matrices CRM[%u] and CRM[%u] have different sizes\n", j, k);
	else
	{
		N = INVERSEMATCR(CRM[j]);
		if (N == NULL)
			printf("CRM[%u] inverse does not exist.\n", j);
		else
		{
			printf("The CRM[%u] transform of CRM[%u] -> \n", j, k);
			Temp1 = MULTMATCR(N, CRM[k]);
			Temp2 = CRM[l];
			CRM[l] = MULTMATCR(Temp1, CRM[j]);
			FREEMATCR(Temp1);
			FREEMATCR(Temp2);
			FREEMATCR(N);
			printf("CRM[%u] = \n", l);
			PRINTMATCR(0, CRM[l]->R - 1, 0, CRM[l]->C - 1, CRM[l]);
		}
	}
	GetReturn();
	return;
}

void SOLVE_CR()
{
	unsigned int j;

	if (scanf01(&j) == 0)
		return;
	printf("Solving the system with augmented matrix CRM[%u] =  \n\n", j);
	PRINTMATCR(0, CRM[j]->R - 1, 0, CRM[j]->C - 1, CRM[j]);
	printf("\n");
	EQUATIONSCR(CRM[j]);
	GetReturn();
	return;
}

void ROW_REDUCE_CR()
{
	unsigned int j, k, r, *D;
	MPMATCR *Temp;

	if (scanf02(&j, &k) == 0)
		return;
	printf("The reduced row-echelon form of CRM[%u] = \n", j);
	PRINTMATCR(0, CRM[j]->R - 1, 0, CRM[j]->C - 1, CRM[j]);
	Temp = CRM[k];
	CRM[k] = GAUSS_JORDANCR(CRM[j], &r, &D);
	FREEMATCR(Temp);
	printf("->\n");
	printf("CRM[%u] = \n", k);
	PRINTMATCR(0, CRM[k]->R - 1, 0, CRM[k]->C - 1, CRM[k]);
	ffree((char *)D, CRM[j]->C * sizeof(unsigned int));
	printf("rank = %u\n", r);
	GetReturn();
	return;
}

void NULL_SPACE_CR()
{
	unsigned int j, k;
	MPMATCR *N;

	if (scanf02(&j, &k) == 0)
		return;
	N = NULL_SPACECR(CRM[j]);
	printf("null-space of CRM[%u] = \n", j);
	PRINTMATCR(0, CRM[j]->R - 1, 0, CRM[j]->C - 1, CRM[j]);
	if (N == NULL)
		printf("= {0}\n");
	else
	{
		FREEMATCR(CRM[k]);
		CRM[k] = N;
		printf("has basis consisting of the columns of the matrix CRM[%u] = \n", k);
		PRINTMATCR(0, CRM[k]->R - 1, 0, CRM[k]->C - 1, CRM[k]);
	}
	GetReturn();
	return;
}

void COLUMN_SPACE_CR()
{
	unsigned int j, k;
	MPMATCR *N;

	if (scanf02(&j, &k) == 0)
		return;
	N = COLUMN_SPACECR(CRM[j]);
	printf("Column-space of CRM[%u] = \n", j);
	PRINTMATCR(0, CRM[j]->R - 1, 0, CRM[j]->C - 1, CRM[j]);
	if (N == NULL)
		printf("= {0}\n");
	else
	{
		FREEMATCR(CRM[k]);
		CRM[k] = N;
		printf("has basis consisting of the columns of the matrix CRM[%u] = \n", k);
		PRINTMATCR(0, CRM[k]->R - 1, 0, CRM[k]->C - 1, CRM[k]);
	}
	GetReturn();
	return;
}

void MATALG_CR()
{
	int GoOnFlag = 1;
	char c;
	while (GoOnFlag)
	{
		c = drawmenu(11);
		switch (c)
		{
		case 'c':
			CHAR_POLY_CR();
			break;
		case 'm':
			MINIMUM_POLY_CR();
			break;
		case 'a':
			ADJ_CR();
			break;
		case 'd':
			DET_CR();
			break;
		case 'i':
			INVERSE_MAT_CR();
			break;
		case 't':
			TRANSFORM_MAT_CR();
			break;
		case 'l':
			SOLVE_CR();
			break;
		case 'g':
			ROW_REDUCE_CR();
			break;
		case 'n':
			NULL_SPACE_CR();
			break;
		case 'b':
			COLUMN_SPACE_CR();
			break;
		case 'p':
			PRINTCR_();
			break;
		case 'x':
			INPUTCR_();
			break;
		case 'q':
			FPRINT_CR(cCR);
			FPRINTMAT_CR(cCRM);
			FPRINT_PCR(cPCR);
			FPRINTMAT_PCR(cPCRM);
			GoOnFlag = 0;
			break;
		}
	}
}
