/* cm_CRM3.c */

/* dot product complex rational routines used in cmCR.c */

#include <stdio.h>
#include "integer.h"
#include "fun.h"

extern MPMATCR *CRM[];
extern MPCR *CR[];

void DOTCR_()
{
	unsigned int j, k, l;

	if (scanf03(&j, &k, &l) == 0)
		return;
	if (CRM[j]->R > 1 || CRM[k]->R > 1)
		printf("CRM[%u] or CRM[%u] is not a row vector\n\n", j, k);
	else if (CRM[j]->C != CRM[k]->C)
		printf("CRM[%u] and CRM[%u] have different dimensions\n\n", j, k);
	else
	{
		printf("CRM[%u] = \n", j);
		PRINTMATCR(0, CRM[j]->R - 1, 0, CRM[j]->C - 1, CRM[j]);
		printf(".\n");
		printf("CRM[%u] = \n", k);
		PRINTMATCR(0, CRM[k]->R - 1, 0, CRM[k]->C - 1, CRM[k]);
		printf("->\n");
		FREEMPCR(CR[l]);
		CR[l] = DOTCR(CRM[j], CRM[k]);
		printf("CR[%u] = ", l);
		PRINTCR(CR[l]);
		printf("\n");
	}
	GetReturn();
	return;
}

void GRAM_SCHMIDTCR_()
{
	unsigned int j, k;
	MPMATCR *Temp;

	if (scanf02(&j, &k) == 0)
		return;
	if (ZEROTESTCR(CRM[j]))
		printf("matrix CRM[%u] is zero\n\n", j);
	else
	{
		printf("CRM[%u] = \n", j);
		PRINTMATCR(0, CRM[j]->R - 1, 0, CRM[j]->C - 1, CRM[j]);
		printf("->\n");
		Temp = CRM[k];
		CRM[k] = GRAM_SCHMIDTCR(CRM[j]);
		FREEMATCR(Temp);
		printf("CRM[%u] = \n", k);
		PRINTMATCR(0, CRM[k]->R - 1, 0, CRM[k]->C - 1, CRM[k]);
	}
	GetReturn();
	return;
}

void DOTLCR_()
{
	unsigned int j, k;

	if (scanf02(&j, &k) == 0)
		return;
	printf("length-squared of CRM[%u] = \n", j);
	PRINTMATCR(0, CRM[j]->R - 1, 0, CRM[j]->C - 1, CRM[j]);
	printf("-> ");
	FREEMPCR(CR[k]);
	CR[k] =	DOTLCR(CRM[j]);
	printf("CR[%u] = ", k);
	PRINTCR(CR[k]);
	printf("\n");
	GetReturn();
	return;
}

void DOT_CR()
{
	int GoOnFlag = 1;
        char c;

	while (GoOnFlag)
	{
		c = drawmenu(27);
		clearscreen();
		switch (c)
		{
		case 'd':
			DOTCR_();
			break;
		case 'g':
			GRAM_SCHMIDTCR_();
			break;
		case 'l':
			DOTLCR_();
			break;
		case 'v':
			ExtractCR_();
			break;
		case 'p':
			PRINTCR_();
			break;
		case 'x':
			INPUTCR_();
			break;
		case 'q':
			GoOnFlag = 0;
		}
	} 
}
