/* cm_PCR.c */
/* rational polynomial routines used in cmCR.c.*/

#include <stdio.h>
#include <stdlib.h>
#include "integer.h"
#include "fun.h"

extern MPCR *CR[];
extern POLYCR PCR[];

void ADD_PCR()
{
	unsigned int j, k, l;
	POLYCR Tmp;

	if (scanf03(&j, &k, &l) == 0)
		return;
	printf("PCR[%u] = ", j);
	PRINTPCR(PCR[j]);
	printf("\n+\nPCR[%u] = ", k);
	PRINTPCR(PCR[k]);
	Tmp = PCR[l];
	PCR[l] = ADDPCR(PCR[j], PCR[k]);
	DELETE_PCR(Tmp);
	printf("\n->\nPCR[%u] = ", l);
	PRINTPCR(PCR[l]);
	printf("\n");
	GetReturn();
	return;
}

void SUB_PCR()
{
	unsigned int j, k, l;
	POLYCR Tmp;

	if (scanf03(&j, &k, &l) == 0)
		return;
	printf("PCR[%u] = ", j);
	PRINTPCR(PCR[j]);
	printf("\n-\nPCR[%u] = ", k);
	PRINTPCR(PCR[k]);
	Tmp = PCR[l];
	PCR[l] = SUBPCR(PCR[j], PCR[k]);
	DELETE_PCR(Tmp);
	printf("\n->\nPCR[%u] = ", l);
	PRINTPCR(PCR[l]);
	printf("\n");
	GetReturn();
	return;
}

void MULT_PCR()
{
	unsigned int j, k, l;
	POLYCR Tmp;

	if (scanf03(&j, &k, &l) == 0)
		return;
	printf("PCR[%u] = ", j);
	PRINTPCR(PCR[j]);
	printf("\n*\nPCR[%u] = ", k);
	PRINTPCR(PCR[k]);
	Tmp = PCR[l];
	PCR[l] = MULTPCR(PCR[j], PCR[k]);
	DELETE_PCR(Tmp);
	printf("\n->\nPCR[%u] = ", l);
	PRINTPCR(PCR[l]);
	printf("\n");
	GetReturn();
	return;
}

void POWER_PCR()
{
	unsigned int j, k, n;
	POLYCR Tmp;

	if (scanf12(&n, &j, &k) == 0)
		return;
	printf("The %u-th power of PCR[%u] = ", n, j);
	PRINTPCR(PCR[j]);
	Tmp = PCR[k];
	PCR[k] = POWERPCR(PCR[j], n);
	DELETE_PCR(Tmp);
	printf("\n->\nPCR[%u] = ", k);
	PRINTPCR(PCR[k]);
	printf("\n");
	GetReturn();
	return;
}

void DIV_PCR()
{
	unsigned int j, k, l;
	POLYCR Tmp;

	if (scanf03(&j, &k, &l) == 0)
		return;
	if (PCR[k] == NULL)
		printf("PCR[%u] = 0 and so PCR[%u] div PCR[%u] does not exist!\n", k, j, k);
	else
	{
		printf("PCR[%u] = ", j);
		PRINTPCR(PCR[j]);
		printf("\ndiv\nPCR[%u] = ", k);
		PRINTPCR(PCR[k]);
		Tmp = PCR[l];
		PCR[l] = DIVPCR(PCR[j], PCR[k]);
		DELETE_PCR(Tmp);
		printf("\n->\nPCR[%u] = ", l);
		PRINTPCR(PCR[l]);
		printf("\n");
	}
	GetReturn();
	return;
}

void MOD_PCR()
{
	unsigned int j, k, l;
	POLYCR Tmp;

	if (scanf03(&j, &k, &l) == 0)
		return;
	if (PCR[k] == NULL)
		printf("PCR[%u] = 0 and so PCR[%u] mod PCR[%u] does not exist!\n", k, j, k);
	else
	{
		printf("PCR[%u] = ", j);
		PRINTPCR(PCR[j]);
		printf("\nmod\nPCR[%u] = ", k);
		PRINTPCR(PCR[k]);
		Tmp = PCR[l];
		PCR[l] = MODPCR(PCR[j], PCR[k]);
		DELETE_PCR(Tmp);
		printf("\n->\nPCR[%u] = ", l);
		PRINTPCR(PCR[l]);
		printf("\n");
	}
	GetReturn();
	return;
}

void SCALAR_PCR()
{
	unsigned int j, k, l;
	POLYCR Tmp;

	if (scanf03(&j, &k, &l) == 0)
		return;
	printf("CR[%u] = ", j);
	PRINTCR(CR[j]);
	printf("\n*\nPCR[%u] = ", k);
	PRINTPCR(PCR[k]);
	Tmp = PCR[l];
	PCR[l] = SCALARPCR(CR[j], PCR[k]);
	DELETE_PCR(Tmp);
	printf("\n->\nPCR[%u] = ", l);
	PRINTPCR(PCR[l]);
	printf("\n");
	GetReturn();
	return;
}

void VAL_PCR()
{
	unsigned int j, k, l;

	if (scanf03(&j, &k, &l) == 0)
		return;
	printf("PCR[%u] = ", j);
	PRINTPCR(PCR[j]);
	printf("\nevaluated at\nCR[%u] = ", k);
	PRINTCR(CR[k]);
	FREEMPCR(CR[l]);
	CR[l] = VALPCR(PCR[j], CR[k]);
	printf("\n->\nCR[%u] = ", l);
	PRINTCR(CR[l]);
	printf("\n");
	GetReturn();
	return;
}

void DERIV_PCR()
{
	unsigned int j, k;
	POLYCR Tmp;

	if (scanf02(&j, &k) == 0)
		return;
	printf("The derivative of PCR[%u] = ", j);
	PRINTPCR(PCR[j]);
	Tmp = PCR[k];
	PCR[k] = DERIVPCR(PCR[j]);
	DELETE_PCR(Tmp);
	printf("\n->\nPCR[%u] = ", k);
	PRINTPCR(PCR[k]);
	printf("\n");
	GetReturn();
	return;
}

void GCD_PCR()
{
	unsigned int j, k, l;
	POLYCR Tmp;

	if (scanf03(&j, &k, &l) == 0)
		return;
	printf("gcd of PCR[%u] = ", j);
	PRINTPCR(PCR[j]);
	printf("\nand\nPCR[%u] = ", k);
	PRINTPCR(PCR[k]);
	Tmp = PCR[l];
	PCR[l] = GCDPCR(PCR[j], PCR[k]);
	DELETE_PCR(Tmp);
	printf("\n->\nPCR[%u] = ", l);
	PRINTPCR(PCR[l]);
	printf("\n");
	GetReturn();
	return;
}

void EUCLID_PCR()
{
	unsigned int j, k, l, m, n;
	POLYCR Tmp1, Tmp2, Tmp3;

	if (scanf05(&j, &k, &m, &n, &l) == 0)
		return;
	printf("gcd of PCR[%u] = ", j);
	PRINTPCR(PCR[j]);
	printf("\nand\nPCR[%u] = ", k);
	PRINTPCR(PCR[k]);
	Tmp1 = PCR[l];
	Tmp2 = PCR[m];
	Tmp3 = PCR[n];
	PCR[l] = EUCLIDPCR(PCR[j], PCR[k], &PCR[m], &PCR[n]);
	DELETE_PCR(Tmp1);
	DELETE_PCR(Tmp2);
	DELETE_PCR(Tmp3);
	printf("\n->\nPCR[%u] = PCR[%u]*PCR[%u]+PCR[%u]*PCR[%u] = ", l, m, j, n, k);
	PRINTPCR(PCR[l]);
	printf("\nwhere\nPCR[%u] = ", m);
	PRINTPCR(PCR[m]);
	printf("\nand\n");
	printf("PCR[%u] = ", n);
	PRINTPCR(PCR[n]);
	printf("\n");
	GetReturn();
	return;
}

void EUCLIDS_PCR()
{
	unsigned int e, n, i, A[M0];
	POLYCR *P, G, *H;

	printf("enter n (2 <= n <= %u) :  the number of polynomials PCR[a], PCR[b],...\n", M0);
	if (scanf10(&n) == 0)
		return;
	if (n < 2)
	{
		printf("n < 2\n");
		return;
	}
	e = 0;
	printf("enter %u array integers a, b, ... (< %u) :", n, M0);
	for (i = 0; i < n; i++)
		e += scanf("%u", &A[i]);
	Flush();
	if (e != n)
	{
		printf("\n\ninput error : entered only %u integers successfully\n", e);	
		GetReturn();
		return;
	}
	for (i = 0; i < n; i++)
	{
		if (A[i] >= M0)
		{
			printf("\n\ninput error : %u-th array integer >= %u\n", i + 1, M0);	
			GetReturn();
			return;
		}
	}
	P = (POLYCR *)mmalloc (n * sizeof(POLYCR));
	for (i = 0; i < n; i++)
		P[i] = COPYPCR(PCR[A[i]]);
	G = EUCLIDSPCR(P, &H, n);
	for (i = 0; i < n; i++)
		DELETE_PCR(P[i]);
	ffree((char *)P, n * sizeof(POLYCR));
	PRINTPCR(G);
	printf(" = gcd of polynomials ");
	for (i = 0; i < n; i++)
		printf("PCR[%u], ", A[i]);
	printf("\n\n");
	DELETE_PCR(G);
	printf(" = ");
	for (i = 0; i < n - 1; i++)
		printf("H[%u]*PCR[%u]+", i, A[i]);
		printf("H[%u]*PCR[%u]\n\n", i, A[i]);
	printf("where\n\n");
	for (i = 0; i < n; i++)
	{
		printf("H[%u] = ", i + 1);
		PRINTPCR(H[i]);	
		DELETE_PCR(H[i]);
		printf("\n");
		GetReturn();
	}
	ffree((char *)H, n * sizeof(POLYCR));
	return;
}

void SQUAREFREE_PCR()
{
	unsigned int j;

	if (scanf01(&j) == 0)
		return;
	if (DEGREEPCR(PCR[j]) <= 0)
		printf("degree PCR[%u] <= 0 and a squarefree decomposition is not defined.\n", j);
	else
	{
		printf("the squarefree decomposition of PCR[%u] =\n", j);
		PRINTPCR(PCR[j]);
		printf("\nis given by\n");
		SQUAREFREEPCR(PCR[j]);
	}
	GetReturn();
	return;
}

void BTRAGER_PCR()
{
	unsigned int i, j, *mults, n;
	int m;
	POLYCR *G;

	if (scanf01(&j) == 0)
		return;
	m = DEGREEPCR(PCR[j]);
	if (m <= 0)
		printf("degree PCR[%u] <= 0 and factorization is not interesting!.\n", j);
	else
	{
		printf("factorizing PCR[%u] = ", j);
		PRINTPCR(PCR[j]);
		printf(" :\n");
		G = TRAGER_PCR(PCR[j], &mults, &n);
		for (i = 0; i < n; i++)
		{
			printf("irreducible factor G[%u] = ", i);
			PRINTPCR(G[i]);
			DELETE_PCR(G[i]);
			printf(": mult'y = %u\n", mults[i]);
		}
		ffree((char *)G, (unsigned int)m * sizeof(POLYCR));
		ffree((char *)mults, (unsigned int)m * sizeof(unsigned int));
	}
	GetReturn();
	return;
}
