/* cm_PmM1.c */

#include <stdio.h>
#include <stdlib.h>
#include "integer.h"
#include "fun.h"

extern POLYm Pm[];
extern MPMATm *mM[];
extern MPMATPm *PmM[];
extern char cmM[];
extern char cPmM[];
extern char cPm[];

void SWAP_ROWSPm_()
{
	unsigned int j, k, p, q, m;
	MPMATPm *Temp;

	if (scanf221(&p, &q, &j, &k, &m) == 0)
		return;
	if (p < 1 || p > PmM[j]->R)
		printf("p < 1 or > number of rows of PmM[%u]\n", j);
	else if (q < 1 || q > PmM[j]->R)
		printf("q < 1 or > number of rows of PmM[%u]\n", j);
	else
	{
		printf("PmM[%u] = \n", j);
		PRINTMATPm(0, PmM[j]->R - 1, 0, PmM[j]->C - 1, PmM[j]);
		printf("->\n");
		Temp = PmM[k];
		PmM[k] = SWAP_ROWSPm(p - 1, q - 1, PmM[j], m);
		FREEMATPm(Temp);
		printf("PmM[%u] = \n", k);
		PRINTMATPm(0, PmM[k]->R - 1, 0, PmM[k]->C - 1, PmM[k]);
	}
	GetReturn();
	return;
}

void SWAP_COLSPm_()
{
	unsigned int j, k, p, q, m;
	MPMATPm *Temp;

	if (scanf221(&p, &q, &j, &k, &m) == 0)
		return;
	if (p < 1 || p > PmM[j]->C)
		printf("p < 1 or > number of columns of PmM[%u]\n", j);
	else if (q < 1 || q > PmM[j]->C)
		printf("q < 1 or > number of columns of PmM[%u]\n", j);
	else
	{
		printf("PmM[%u] = \n", j);
		PRINTMATPm(0, PmM[j]->R - 1, 0, PmM[j]->C - 1, PmM[j]);
		printf("->\n");
		Temp = PmM[k];
		PmM[k] = SWAP_COLSPm(p - 1, q - 1, PmM[j], m);
		FREEMATPm(Temp);
		printf("PmM[%u] = \n", k);
		PRINTMATPm(0, PmM[k]->R - 1, 0, PmM[k]->C - 1, PmM[k]);
	}
	GetReturn();
	return;
}

void SCALAR_ROWPm_()
{
	unsigned int j, k, l, p, m;
	MPMATPm *Temp;

	if (scanf221(&j, &p, &k, &l, &m) == 0)
		return;
	if (p < 1 || p > PmM[k]->R)
		printf("p < 1 or > number of rows of PmM[%u]\n", k);
	else
	{
		printf("PmM[%u] = \n", k);
		PRINTMATPm(0, PmM[k]->R - 1, 0, PmM[k]->C - 1, PmM[k]);
		printf(" (mod %u) ->\n", m);
		Temp = PmM[l];
		PmM[l] = SCALAR_ROWPm(p - 1, j, PmM[k], m);
		FREEMATPm(Temp);
		printf("PmM[%u] = \n", l);
		PRINTMATPm(0, PmM[l]->R - 1, 0, PmM[l]->C - 1, PmM[l]);
	}
	GetReturn();
	return;
}

void SCALAR_COLPm_()
{
	unsigned int j, k, l, p, m;
	MPMATPm *Temp;

	if (scanf221(&j, &p, &k, &l, &m) == 0)
		return;
	if (p < 1 || p > PmM[k]->C)
		printf("p < 1 or > number of columns of PmM[%u]\n", k);
	else
	{
		printf("PmM[%u] = \n", k);
		PRINTMATPm(0, PmM[k]->R - 1, 0, PmM[k]->C - 1, PmM[k]);
		printf(" (mod %u) ->\n", m);
		Temp = PmM[l];
		PmM[l] = SCALAR_COLPm(p - 1, j, PmM[k], m);
		FREEMATPm(Temp);
		printf("PmM[%u] = \n", l);
		PRINTMATPm(0, PmM[l]->R - 1, 0, PmM[l]->C - 1, PmM[l]);
	}
	GetReturn();
	return;
}

void ADD_MULT_ROWPm_()
{
	unsigned int j, k, l, p, q, m;
	MPMATPm *Temp;

	if (scanf01221(&j, &p, &q, &k, &l, &m) == 0)
		return;
	if (q < 1 || q > PmM[k]->R)
		printf("q < 1 or > number of rows of PmM[%u]\n", k);
	else if (p < 1 || p > PmM[k]->R)
		printf("p < 1 or > number of rows of PmM[%u]\n", k);
	else
	{
		printf("PmM[%u] = \n", k);
		PRINTMATPm(0, PmM[k]->R - 1, 0, PmM[k]->C - 1, PmM[k]);
		printf(" (mod %u) ->\n", m);
		Temp = PmM[l];
		PmM[l] = ADD_MULT_ROWPm(p - 1, q - 1, Pm[j], PmM[k], m);
		FREEMATPm(Temp);
		printf("PmM[%u] = \n", l);
		PRINTMATPm(0, PmM[l]->R - 1, 0, PmM[l]->C - 1, PmM[l]);
	}
	GetReturn();
	return;
}

void ADD_MULT_COLPm_()
{
	unsigned int j, k, l, p, q, m;
	MPMATPm *Temp;

	if (scanf01221(&j, &p, &q, &k, &l, &m) == 0)
		return;
	if (q < 1 || q > PmM[k]->C)
		printf("q < 1 or > number of columns of PmM[%u]\n", k);
	else if (p < 1 || p > PmM[k]->C)
		printf("p < 1 or > number of columns of PmM[%u]\n", k);
	else
	{
		printf("PmM[%u] = \n", k);
		PRINTMATPm(0, PmM[k]->R - 1, 0, PmM[k]->C - 1, PmM[k]);
		printf(" (mod %u) ->\n", m);
		Temp = PmM[l];
		PmM[l] = ADD_MULT_COLPm(p - 1, q - 1, Pm[j], PmM[k], m);
		FREEMATPm(Temp);
		printf("PmM[%u] = \n", l);
		PRINTMATPm(0, PmM[l]->R - 1, 0, PmM[l]->C - 1, PmM[l]);
	}
	GetReturn();
	return;
}

void OPS_Pm()
{
	int GoOnFlag = 1;
        char c;

	while (GoOnFlag)
	{
		c = drawmenu(13);
		switch (c)
		{
		case 'i':
			SWAP_ROWSPm_();
			break;
		case 'j':
			SWAP_COLSPm_();
			break;
		case 'm':
			SCALAR_ROWPm_();
			break;
		case 'n':
			SCALAR_COLPm_();
			break;
		case 'a':
			ADD_MULT_ROWPm_();
			break;
		case 'b':
			ADD_MULT_COLPm_();
			break;
		case 'x':
			INPUTm_();
			break;
		case 'q':
			FPRINT_Pm(cPm);
			FPRINTMAT_Pm(cPmM);
			GoOnFlag = 0;
			break;
		}
	} 
}

void IDENTITY_Pm()
{
	unsigned int m, j;

	if (scanf11(&m, &j) == 0)
		return;
	if (m == 0)
		printf("m == 0\n");
	else
	{
		FREEMATPm(PmM[j]);
		PmM[j] = IDENTITYPm(m);
		printf("PmM[%u] = \n\n", j);
		PRINTMATPm(0, PmM[j]->R - 1, 0, PmM[j]->C - 1, PmM[j]); 
	}
	GetReturn();
	return;
}

void DIAG_Pm()
{
	unsigned int j, k, m;

	if (scanf021(&j, &k, &m) == 0)
		return;
	if (mM[j]->R != mM[j]->C)
		printf("Matrix mM[%u] is not square\n", j);
	else
	{
		printf("xI[%u]\n", mM[j]->R);
		printf("- mM[%u] = \n", j);
		PRINTMATm(0, mM[j]->R - 1, 0, mM[j]->C - 1, mM[j]);
		FREEMATPm(PmM[k]);
		PmM[k] = DIAGXPm(mM[j], m);
		printf(" (mod %u) ->\n", m);
		printf("PmM[%u] = \n", k);
		PRINTMATPm(0, PmM[k]->R - 1, 0, PmM[k]->C - 1, PmM[k]);
	}
	GetReturn();
	return;
}

void ADJ_Pm()
{
	unsigned int j, k, m;
	POLYm A;
	MPMATPm *Temp;

	if (scanf021(&j, &k, &m) == 0)
		return;
	if (PmM[j]->R != PmM[j]->C)
		printf("Matrix PmM[%u] is not square\n", j);
	else if (PmM[j]->R == 1)
		printf("PmM[%u] is 1 x 1\n", j);
	else
	{
		printf("adj of PmM[%u] = \n", j);
		PRINTMATPm(0, PmM[j]->R - 1, 0, PmM[j]->C - 1, PmM[j]);
		Temp = PmM[k];
		A = LEVERRIER_Pm(PmM[j], &PmM[k], m);
		DELETE_Pm(A);
		FREEMATPm(Temp);
		printf(" (mod %u) ->\n", m);
		printf("PmM[%u] = \n", k);
		PRINTMATPm(0, PmM[k]->R - 1, 0, PmM[k]->C - 1, PmM[k]);
	}
	GetReturn();
	return;
}

void DET_Pm()
{
	unsigned int j, k, m;
	MPMATPm *adj;

	if (scanf021(&j, &k, &m) == 0)
		return;
	if (PmM[j]->R != PmM[j]->C)
		printf("Matrix PmM[%u] is not square\n", j);
	else if (PmM[j]->R == 1)
		printf("PmM[%u] is 1 x 1\n", j);
	else
	{
		printf("det of PmM[%u] = \n", j);
		PRINTMATPm(0, PmM[j]->R - 1, 0, PmM[j]->C - 1, PmM[j]);
		DELETE_Pm(Pm[k]);
		Pm[k] = LEVERRIER_Pm(PmM[j], &adj, m);
		FREEMATPm(adj);
		printf("->\n");
		printf("Pm[%u] = ", k);
		PRINTPm(Pm[k]);
		printf("\n");
	}
	GetReturn();
	return;
}

void SMITH_Pm()
{
	unsigned int i, j, k, l, m, p, q, r, z;
	POLYm *A;
	MPMATPm *Temp1, *Temp2;

	if (scanf031(&j, &k, &l, &m) == 0)
		return;
	ZEROTESTPm(0, PmM[j], &p, &q);
	if (p == PmM[j]->R && q == PmM[j]->C)
		printf("PmM[%u] is a zero matrix\n", j);
	else
	{
		printf("The invariant factors (mod %u) of PmM[%u] = \n", m, j);
		PRINTMATPm(0, PmM[j]->R - 1, 0, PmM[j]->C - 1, PmM[j]);
		z = (PmM[j]->R >= PmM[j]->C) ? PmM[j]->C : PmM[j]->R;
		Temp1 = PmM[l];
		Temp2 = PmM[k];
		A = SMITHPm(PmM[j], &PmM[k], &PmM[l], &r, m);
		printf("are\n\n");
		for (i = 0; i < r; i++)
		{
			printf("invariant factor d[%u] = ", i + 1);
			PRINTPm(A[i]);
			printf("\n");
			DELETE_Pm(A[i]);
		}
		ffree((char *) A, z * sizeof(POLYm));
		FREEMATPm(Temp1);
		FREEMATPm(Temp2);
		GetReturn();
		printf("PmM[%u] = \n", k);
		PRINTMATPm(0, PmM[k]->R - 1, 0, PmM[k]->C - 1, PmM[k]);
		printf("\n");
		GetReturn();
		printf("PmM[%u] = \n", l);
		PRINTMATPm(0, PmM[l]->R - 1, 0, PmM[l]->C - 1, PmM[l]);
		printf("\n");
	}
	GetReturn();
	return;
}

void SMITH1A_Pm()
{
	int z;
	unsigned int i, r, j, m, c = 0;
	POLYm *A;
	MPMATPm *M;

	if (scanf011(&j, &m) == 0)
		return;
	printf("The invariant factors (mod %u) of mM[%u] = \n", m, j);
	PRINTMATm(0, mM[j]->R - 1, 0, mM[j]->C - 1, mM[j]);
	M = DIAGXPm(mM[j], m);
	A = SMITH1Pm(M, &r, m);
	z = (M->R >= M->C) ? M->C : M->R;
	FREEMATPm(M);
	printf("are\n\n");
	for (i = 0; i <= r - 1; i++)
	{
		if (A[i]->DEG)
		{
			c++;
			printf("invariant factor d[%u] = ", c);
			PRINTPm(A[i]);
			printf("\n");
		}
		DELETE_Pm(A[i]);
	}
	ffree((char *) A, z * sizeof(POLYm));
	GetReturn();
	return;
}

void MATRIX_ARITH_Pm()
{
	char c;
	int GoOnFlag;
	GoOnFlag = 1;
	while (GoOnFlag)
	{
		c = drawmenu(12);
		switch (c)
		{
			case 'o':
				OPS_Pm();
				break;
			case 'i':
				IDENTITY_Pm();
				break;
			case 'e':
				DIAG_Pm();
				break;
			case 'a':
				ADJ_Pm();
				break;
			case 'd':
				DET_Pm();
				break;
			case 'f':
				SMITH_Pm();
				break;
			case 'F':
				SMITH1A_Pm();
				break;
			case 'x':
				INPUTm_();
				break;
			case 'p':
				PRINTm_();
				break;
			case 'q':
				FPRINTMAT_m(cmM);
				FPRINT_Pm(cPm);
				FPRINTMAT_Pm(cPmM);
				GoOnFlag = 0;
				break;
		}
	} 
}
