/* cm_R.c */
/* rational number routines used in cmR.c.*/

#include <stdio.h>
#ifndef _WIN32
#include "cmat.h"
#endif
#include "integer.h"
#include "fun.h"

extern MPR *R[];

void ADD_R()
{
	unsigned int j, k, l;

	if (scanf03(&j, &k, &l) == 0)
		return;
	printf("R[%u] = ", j);
	PRINTR(R[j]);
	printf(" + R[%u] = ", k);
	PRINTR(R[k]);
	FREEMPR(R[l]);
	R[l] = ADDR(R[j], R[k]);
	printf(" -> R[%u] = ", l);
	PRINTR(R[l]);
	printf("\n");
	GetReturn();
	return;
}

void SUB_R()
{
	unsigned int j, k, l;

	if (scanf03(&j, &k, &l) == 0)
		return;
	printf("R[%u] = ", j);
	PRINTR(R[j]);
	printf(" - R[%u] = ", k);
	PRINTR(R[k]);
	FREEMPR(R[l]);
	R[l] = SUBR(R[j], R[k]);
	printf(" -> R[%u] = ", l);
	PRINTR(R[l]);
	printf("\n");
	GetReturn();
	return;
}

void MULT_R()
{
	unsigned int j, k, l;

	if (scanf03(&j, &k, &l) == 0)
		return;
	printf("R[%u] = ", j);
	PRINTR(R[j]);
	printf(" * R[%u] = ", k);
	PRINTR(R[k]);
	FREEMPR(R[l]);
	R[l] = MULTR(R[j], R[k]);
	printf(" -> R[%u] = ", l);
	PRINTR(R[l]);
	printf("\n");
	GetReturn();
	return;
}

void POWER_R()
{
	unsigned int n, j, k;

	if (scanf12(&n, &j, &k) == 0)
		return;
	printf("The %u-th power of R[%u] = ", n, j);
	PRINTR(R[j]);
	FREEMPR(R[k]);
	R[k] = POWERR(R[j], n);
	printf(" -> R[%u] = ", k);
	PRINTR(R[k]);
	printf("\n");
	GetReturn();
	return;
}

void RATIO_R()
{
	unsigned int j, k, l;

	if (scanf03(&j, &k, &l) == 0)
		return;
	if (EQZEROR(R[k]))
		printf("R[%u] = 0 and so R[%u]/R[%u] does not exist!\n", k, j, k);
	else
	{
		printf("R[%u] = ", j);
		PRINTR(R[j]);
		printf(" / R[%u] = ", k);
		PRINTR(R[k]);
		FREEMPR(R[l]);
		R[l] = RATIOR(R[j], R[k]);
		printf(" -> R[%u] = ", l);
		PRINTR(R[l]);
		printf("\n");
	}
	GetReturn();
	return;
}

void INVERSE_R()
{
	unsigned int j, k;

	if (scanf02(&j, &k) == 0)
		return;
	if (EQZEROR(R[j]))
		printf("R[%u] = 0 and has no inverse\n", j);
	else
	{
		printf("The inverse of R[%u] = ", j);
		PRINTR(R[j]);
		FREEMPR(R[k]);
		R[k] = INVERSER(R[j]);
		printf(" -> R[%u] = ", k);
		PRINTR(R[k]);
		printf("\n");
	}
	GetReturn();
	return;
}

void MTHROOT_R()
{
	unsigned int m, r, j, k;

	if (scanf22(&m, &r, &j, &k) == 0)
		return;
	printf("The %u-th power to %u places of R[%u] = ", m, r, j);
	PRINTR(R[j]);
	if (m <= 1)
	{
		printf("m <= 1\n");
		return;
	}
	FREEMPR(R[k]);
	R[k] = MTHROOTR(R[j], m, r);
	printf(" -> R[%u] = ", k);
	PRINTR(R[k]);
	printf("\n");
	GetReturn();
	return;
}
