/* p1I.c */

#include <stdio.h>
#include <stdlib.h>
#include "integer.h"
#include "fun.h"

extern long int nettbytes;
 
MPMATPI *BUILDMATPI(USI m, USI n)
/*
 * Allocates space for an m x n matrix of POLYI's.
 */
{
	unsigned int i;
	MPMATPI *N;

	N=(MPMATPI *)mmalloc(sizeof(MPMATPI));
	N->R = m;
	N->C = n;
	N->V = (POLYI **)mmalloc(m * sizeof(POLYI *));
	for (i = 0; i <= m - 1; i++)
		*(N->V + i) = (POLYI *)mmalloc(n * sizeof(POLYI));
	return (N);
}

MPMATPI *COPYMATPI(MPMATPI *Mptr)
/*
 * a replacement for the assignment *Nptr = *Mptr
 */
{
	unsigned int i, j;
	MPMATPI *Nptr;

	Nptr = BUILDMATPI(Mptr->R, Mptr->C);
	for (i = 0; i <= Mptr->R - 1; i++)
	{
		for (j = 0; j <= Mptr->C - 1; j++)
			Nptr->V[i][j] = COPYPI(Mptr->V[i][j]);
	}
	return (Nptr);
}

void FREEMATPI(MPMATPI *Mptr)
/*
 *  frees the storage allocated to the two-dimensional array Mptr->V.
 */
{
	unsigned int i, j;

	if (Mptr == NULL)
		return;
	for (i = 0; i < Mptr->R; i++)
	{
		for (j = 0; j < Mptr->C; j++)
			DELETE_PI(Mptr->V[i][j]);
		ffree((char *)(*(Mptr->V + i)), Mptr->C * sizeof(POLYI));
	}
	ffree((char *)(Mptr->V), Mptr->R * sizeof(POLYI *));
	ffree((char *)Mptr, sizeof(MPMATPI));
}

MPMATPI *ZEROMNPI(USI m, USI n)
/*
 *  returns the zero  m x n matrix of POLYI's.
 */
{
	unsigned int i, j;
	MPMATPI *Mptr;

	Mptr = BUILDMATPI(m, n);
	for (i = 0; i <= m - 1; i++)
	{
		for (j = 0; j <= n - 1; j++)
			Mptr->V[i][j] = NULL;
	}
	return (Mptr);
}

MPMATPI *INPUTMATPI()
/*
 * inputting a matrix of POLYI'S.
 */
{
	unsigned int u, i, j, m, n;
	MPMATPI *Mptr;

	printf("Enter the number of rows and number of columns\n");
	if (scanf("%u%u", &m, &n) != 2 || m == 0 || n == 0)
	{
		fprintf(stderr, "corrupt input: returning the 1 x 1 zero matrix\n");
		return ZEROMNPI(1, 1);
	}
	getchar();
	Mptr = ZEROMNPI(m, n);
	for (i = 0; i <= m - 1; i++) 
        {
		printf("Enter row %u:\n", i + 1);
		for (j = 0; j <= n - 1; j++) 
		{
			printf("Entering polynomial[%u][%u]:\n", i + 1, j + 1);
			Mptr->V[i][j] = INPUTPI(&u);
			if (u == 0)
			{
				printf("matrix input prematurely interrupted\n");
				GetReturn();
				return Mptr;
			}
			printf("Polynomial[%u][%u] = ", i + 1, j + 1);
			PRINTPI(Mptr->V[i][j]);
			printf("\n");
		}
	}
	return (Mptr);
}
