/*
 * rc.c
 * Initializes global variables with what is in the cmatrc file.
 * Arcane stuff written by Sean Vickery.
 */

#include <stdio.h>
#include <stdlib.h>
#include "integer.h"
#include "fun.h"
#include "cmat.h"

FILE *fopenhd(char *name, char *mode, char *dir);
/*
 * Work out what files are called and what the defaults are by working out
 * whether this is the MSDOS or UNIX version.
 */

#define SETSIZE 64
#define NAMESIZE 16
#define MAXLINE 80

struct SYMBOLMAP {
	char name[NAMESIZE], *variable;
};

#ifndef _WIN32
#define RCFILE ".cmatrc"
#endif

/* these are dependent on how you organize cmat on your machine */
char CMATPATH[SETSIZE] = DEFAULTCMATPATH;
char DATPATH[SETSIZE] = DEFAULTDATPATH;
#ifndef _WIN32
char PAGER[SETSIZE] = DEFAULTPAGER;

struct SYMBOLMAP symbol_map[] = {
	"datpath", DATPATH,
	"cmat", CMATPATH,
	"", NULL};
#endif

int readrc()
/*
 * Sets up the global strings DATPATH etc on what's in the rc file.
 * Also sets up global strings on environment variables, eg PAGER.
 */
{
#ifndef _WIN32
	FILE *rc;
	int i, j, k;
	char inputline[MAXLINE], symbol[NAMESIZE], *ep;
	/* set up PAGER */

	if ((ep = getenv("PAGER")))
		strcpy(PAGER, ep);
	/* read in rc file */
	if ((rc = fopenhd(RCFILE, "r", DEFAULTRC)))
		while (fgets(inputline, MAXLINE, rc) != NULL) {
			if (inputline[strlen(inputline) - 1] != '\n')
				fatal_error("Line in %s too long.", RCFILE,(char *)NULL);
			for (i = 0; i < NAMESIZE - 1 && inputline[i] != '='; i++)
				symbol[i] = inputline[i];
			if (i == NAMESIZE - 1)
				fatal_error("Symbol in %s too long.", RCFILE,(char *)NULL);
			symbol[i++] = '\0';
			for (j = 0; symbol_map[j].variable && strcmp(symbol_map[j].name, symbol); j++)
				;
			if (symbol_map[j].variable == NULL)
				fatal_error("Unknown variable %s in %s.", symbol, RCFILE);
			for (k = 0; inputline[i + k] != '\n'; k++)
				symbol_map[j].variable[k] = inputline[i + k];
			symbol_map[j].variable[k] = '\0';
		}
#endif
	return 0;
}
