/*
 * util.c
 * Contains small ancillary (?) functions.
 * fopenhp()
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>

#include "cmat.h"
#include "integer.h"
#include "fun.h"

#ifdef _WIN32

#define PATHSEP ';'
#define DIRSEP '\\'

#else 

#define PATHSEP ':'
#define DIRSEP '/'

#endif /* _WIN32 */

/* declarations */
char *getenv();

FILE *fopenhd(char *name, char *mode, char *dir)
/*
 * Trys to open the named file.
 * Looks in the following places in the following order:
 *   1. The default directory
 *   2. The user's home directory (if the HOME variable is set)
 *   3. In the directory given as an argument
 */
{
	FILE *fp;
	char *ep, *bp, buf[512];
	/* try default directory first */
	if ((fp = fopen(name, mode)) != NULL)
		return fp;					/* successful in default directory */
	/* try to open in home directory */
	ep = getenv("HOME");
	if (ep) {
		bp = buf;
		while (*ep)
			*bp++ = *ep++;
		*bp++ = DIRSEP;
		strcpy(bp, name);
		if ((fp = fopen(buf, mode)) != NULL)
			return fp;
	}
	/* try to open in given directory */
	if (dir) {
		bp = buf;
		while (*dir)
			*bp++ = *dir++;
		*bp++ = DIRSEP;
		strcpy(bp, name);
		if ((fp = fopen(buf, mode)) != NULL)
			return fp;
	}
	return NULL;
}
